Subarrays with K Different Integers | Approach-1 | With Reasons | Leetcode 992 | codestorywithMIK
iPad PDF Notes - https://github.com/MAZHARMIK/Interview_DS_Algo/blob/master/iPad%20PDF%20Notes/Leetcode-992-Subarrays%20with%20K%20Different%20Integers.pdf
Whatsapp Community Link : https://www.whatsapp.com/channel/0029Va6kVSjICVfiVdsHgi1A
This is the 19th Video of our Playlist "Sliding Window : Popular Interview Problems".
In this video we will try to solve an very classic sliding window problem :
Subarrays with K Different Integers | Approach-1 | With Reasons | Leetcode 992 | codestorywithMIK
I will explain the intuition so easily that you will never forget and start seeing this as cakewalk EASYYY.
We will do live coding after explanation and see if we are able to pass all the test cases.
Also, please note that my Github solution link below contains both C++ as well as JAVA code.
Problem Name : Subarrays with K Different Integers | Approach-1 | With Reasons | Leetcode 992 | codestorywithMIK
Company Tags : Expedia, Uber, Amazon
My solutions on Github(C++ & JAVA) : https://github.com/MAZHARMIK/Interview_DS_Algo/blob/master/Sliding%20Window/Subarrays%20with%20K%20Different%20Integers.cpp
Leetcode Link : https://leetcode.com/problems/subarrays-with-k-different-integers/
My DP Concepts Playlist : https://youtu.be/7eLMOE1jnls
My Graph Concepts Playlist : https://youtu.be/5JGiZnr6B5w
My Recursion Concepts Playlist : https://www.youtube.com/watch?v=pfb1Zduesi8&list=PLpIkg8OmuX-IBcXsfITH5ql0Lqci1MYPM
My Sliding Window Playlist : https://www.youtube.com/watch?v=mrUBUWb23hk&list=PLpIkg8OmuX-J2Ivo9YdY7bRDstPPTVGvN&index=1
My GitHub Repo for interview preparation : https://github.com/MAZHARMIK/Interview_DS_Algo
Instagram : https://www.instagram.com/codestorywithmik/
Facebook : https://www.facebook.com/people/codestorywithmik/100090524295846/
Twitter : https://twitter.com/CSwithMIK
Subscribe to my channel : https://www.youtube.com/@codestorywithMIK
Approach Summary :
The provided Java code implements an approach to find the total count of subarrays having at most k distinct elements within an array of integers. This is achieved using a sliding window technique combined with a HashMap data structure for efficient tracking of distinct elements within the window.
The `slidingWindow` method iterates through the array using two pointers, `i` and `j`, to define the current window. It maintains a HashMap (`mp`) to store the frequency of elements within the window. The window expands by incrementing `j` and updates the HashMap accordingly. When the number of distinct elements exceeds `k`, the window shrinks by incrementing `i`, updating the HashMap, and thus ensuring that the window contains at most `k` distinct elements.
The `subarraysWithKDistinct` method utilizes the `slidingWindow` method twice. First, it calculates the count of subarrays with at most `k` distinct elements. Then, it calculates the count of subarrays with exactly `k` distinct elements by subtracting the count of subarrays with at most `k-1` distinct elements from the count of subarrays with at most `k` distinct elements.
╔═╦╗╔╦╗╔═╦═╦╦╦╦╗╔═╗
║╚╣║║║╚╣╚╣╔╣╔╣║╚╣═╣
╠╗║╚╝║║╠╗║╚╣║║║║║═╣
╚═╩══╩═╩═╩═╩╝╚╩═╩═╝
✨ Timelines✨
00:00 - Introduction
2:20 - Will Normal Sliding Window Work ?
7:43 - What's the Problem ?
9:36 - Intuition +How to solve it ?
30:30 - Coding it up + Time & Space Complexity
#coding #helpajobseeker #easyrecipes #leetcode #leetcodequestionandanswers #leetcodesolution #leetcodedailychallenge #leetcodequestions #leetcodechallenge #hindi #india #coding #helpajobseeker #easyrecipes #leetcode #leetcodequestionandanswers #leetcodesolution #leetcodedailychallenge#leetcodequestions #leetcodechallenge #hindi #india #hindiexplanation #hindiexplained #easyexplaination #interview#interviewtips #interviewpreparation #interview_ds_algo #hinglish #github #design #data #google #video #instagram #facebook #leetcode #computerscience #leetcodesolutions #leetcodequestionandanswers #code #learning #dsalgo #dsa #newyear2024